public class Problem030 {
    public static void main(String[] args) {
        // Precompute the fifth powers of digits 0 to 9
        int[] powers = {0, 1, 32, 243, 1024, 3125, 7776, 16807, 32768, 59049};
        
        // Initialize total sum
        long totalSum = 0;
        
        // Set upper limit; numbers beyond this cannot satisfy the condition
        int upperLimit = 354294; // 6 * 9^5
        
        // Loop through numbers from 2 to upperLimit
        for (int n = 2; n <= upperLimit; n++) {
            // Calculate sum of fifth powers of digits
            int sum = 0;
            int temp = n;
            while (temp > 0) {
                int digit = temp % 10;
                sum += powers[digit];
                temp /= 10;
            }
            // If sum equals the number itself, add to totalSum
            if (sum == n) {
                totalSum += n;
            }
        }
        
        // Print the total sum
        System.out.println(totalSum);
    }
}
