import java.util.*;
import java.math.*;

public class Problem003 {
	/*
	
	The prime factors of 13195 are 5, 7, 13 and 29.
	
	What is the largest prime factor of the number 600851475143 ?
	
	*/

	public static void main(String[] args) { 
		BigInteger n = new BigInteger("600851475143");

		ArrayList<BigInteger> factors = new ArrayList<BigInteger>();
		BigInteger f = new BigInteger("2");
		System.out.println("Beginning search for factors...");

		// This should actually only go to sqrt(n), but...
		while(f.compareTo(n)<0) { 
			if( n.mod(f).equals(BigInteger.ZERO) ) { 
				System.out.println("Found a factor! "+f);
				// Remove it, reset stuff, keep looking.
				factors.add(f);
				n = n.divide(f); 
				//n /= f;
				f = new BigInteger("2");
			} else {
				f = f.add(new BigInteger("1"));
			}
		}
		factors.add(f);
		System.out.println(factors);
		System.out.println("Largest factor: " + Collections.max(factors));
	}
}