import java.math.MathContext;
import java.math.RoundingMode;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Arrays;

public class Problem065 {

	public static void main(String[] args) { 
		solve();
	}

	public static void solve() {
		int EXTRA = 5;
		int NTERMS = 100;

		// Returns an array list of size NTERMS+1
		List<Integer> cf = Convergents.continuedFractionE(NTERMS+EXTRA);
		BigInteger[] conv = Convergents.convergents(cf,NTERMS);

		int sum = sumDigits( conv[0].toString() );
		System.out.println(sum);
	}

	public static int sumDigits(String bignum) { 
		int sum = 0;
		for(int i=0; i<bignum.length(); i++) { 
			sum += Character.digit(bignum.charAt(i),10);
		}
		return sum;
	}

}
