import java.util.Arrays;

public class BruteForce {

	public static int max = 0;
	public static String maxPath = "";


	public static void main(String[] args) {
		System.out.println(bruteForcePath());
		//System.out.println(maxPath);
	}


	public static int bruteForcePath() {
		int[][] triangle = LoadTriangle.loadTriangle();
		int dim = triangle.length;

		boolean[] goright = new boolean[dim];
		bruteForce(0, goright, triangle);

		return max;
	}

	public static void bruteForce(int depth, boolean[] goright, int[][] triangle) {
		int dim = triangle.length;
		if(depth==dim) {
			// Base case:
			// take the path dictated by z
			StringBuilder sb = new StringBuilder();
			int sum = 0;
			int c = 0;
			int r = 0;
			sum += triangle[0][0];
			sb.append(triangle[0][0]+" ");
			for(r = 1; r<goright.length; r++){
				if(goright[r-1]) { 
					c++;
				}
				sum += triangle[r][c];
				sb.append(triangle[r][c]+" ");
			}
				sb.append("= "+sum);
			if(sum>max) { 
				max = sum;
				maxPath = sb.toString();
			}
	 	} else {
			// Recursive case:
			// Call brute force method for both choices
			goright[depth] = true;
			bruteForce(depth+1, goright, triangle);
			goright[depth] = false;
			bruteForce(depth+1, goright, triangle);
		}
	}
				



	public static boolean goLeft(int i, int j, int[][] triangle) { 
		int leftSubtreeSum  = subtreeSum( i+1, j, triangle);
		int rightSubtreeSum = subtreeSum( i+1, j+1, triangle);
		return (leftSubtreeSum >= rightSubtreeSum);
	}


	public static int subtreeSum(int r, int c, int[][] triangle) { 
		int sum = 0;
		int dim = triangle.length;
		for(int i=0; r+i<dim; i++){
			for(int j=0; j<=i; j++) { 
				sum += triangle[r+i][c+j];
			}
		}
		return sum;
	}
}

