# Project Euler: Problem 254: Sum of Digit Factorials

Define f(n) as the sum of the factorials of the digits of n. 
For example, f(342) = 3! + 4! + 2! = 32.

Define sf(n) as the sum of the digits of f(n). 
So sf(342) = 3 + 2 = 5.

Define g(p) to be the smallest positive integer n such that sf(n) = p. 
Though sf(342) is 5, sf(25) is also 5, and it can be verified that g(5) is 25.

Define sg(i) as the sum of the digits of g(i). 
So sg(5) = 2 + 5 = 7.
Further, it can be verified that g(20) is 267,
and sum( sg(i) ) for 1 <= i <= 20 is 156.

What is sum( sg(i) ) for 1 <= i <= 150?
