/**
 * Project Euler: Problem 6.
 *
 * The sum of the squares of the first 10 integers is x.
 * The square of the sum of the first 10 integers is y.
 * Their difference is y-x.
 *
 * Find this for the first 100 integers.
 */
public class Problem006 implements EulerSolution {

	public String run() { 
		int n = 100;
		int small = sum_of_squares(n);
		int big = square_of_sum(n);
		return new Integer(big - small).toString();
	}

	/** Formula for the sum of the square of integers up to N. */
	public static int sum_of_squares(int n) { 
		int result = (n*(n+1)*(2*n+1))/6;
		return result;
	}

	/** Formula for the sum of the integers up to N, squared. */
	public static int square_of_sum(int n) { 
		int result = (n*(n+1))/2;
		result *= result;
		return result;
	}
}
