import java.util.List;
import java.util.LinkedList;
import java.util.ArrayList;

/** Sum of Primes Below 2 Million.
 */
public class Problem010 implements EulerSolution { 
	public static void main(String[] args) { 
		Problem010 p = new Problem010();
		System.out.println(p.run());
	}

	public String run() {
		int TWO_MILLION = 2000000;
		List<Long> primes = Sieve.primeSieveLong(TWO_MILLION);
		Long sum = sumList(primes);
		return sum.toString();
	}

	/** Sum up all the elements in a list and return it. */
	public static Long sumList(List<Long> list) {
		Long sum = new Long(0);
		for(Long i : list) { 
			sum += i;
		}
		return sum;
	}

}

