import java.math.BigInteger;

/** Sum of digits of 100!.
 *
 * This is a straightforward use of BigInteger.
 */
public class Problem020 implements EulerSolution { 
	public String run() { 
		int N = 100;
		BigInteger b = BigInteger.ONE;
		for(int i=1; i<=N; i++) { 
			BigInteger next = new BigInteger(Integer.toString(i));
			b = b.multiply(next);
		}
		char[] digits = b.toString().toCharArray();
		int sum = 0;
		for(int j=0; j<digits.length; j++) { 
			int k = Character.digit(digits[j],10);
			//int k = (int)(digits[j]);
			sum += k;
		}
		return Integer.toString(sum);
	}
}
