import java.util.Arrays;

public class Bottom {
	public static void main(String[] args) { 
		System.out.println(fromBottom());
	}

	public static int fromBottom() { 
		int[][] triangle = LoadTriangle.loadTriangle();
		int[][] triangleSum = LoadTriangle.loadTriangle();
		int dim = triangle.length;
		int sum = 0;
		// Rows go from second to last to first
		for(int r=dim-2; r>=0; r--) { 
			// Columns go from 0 to r
			for(int j=0; j<=r; j++) {
				// Find maximum path for this three-element subtree
				int left = triangleSum[r+1][j];
				int right = triangleSum[r+1][j+1];
				if(left > right) { 
					triangleSum[r][j] = triangleSum[r+1][j] + triangle[r][j];
				} else {
					triangleSum[r][j] = triangleSum[r+1][j+1] + triangle[r][j];
				}
			}
		}
		return triangleSum[0][0];
	}
}